//HavokManager.h

#ifndef		_HAVOKMANAGER_H
#define		_HAVOKMANAGER_H

class	hkJobQueue;
class	hkJobThreadPool;
class	hkVisualDebugger;
class	hkpPhysicsContext;
class	hkStopwatch;
class	hkLoader;

#include "HavokDefine.h"

#ifdef USE_HAVOKDEMO  
class HavokManager : public hkReferencedObject
#else
class HavokManager 
#endif
{
public:
#ifdef USE_HAVOKDEMO
	HK_DECLARE_CLASS_ALLOCATOR(HK_MEMORY_CLASS_DEMO);
#endif
	enum 
	{
		LAYER_STATIC_BACKGROUND = 1,
		LAYER_ACTOR = 2,
	};

	static	bool	CreateInstance( bool bMultithread );
	//Ϻ 𿡼 ϱ ؼ
	static  bool	CreateHavokDemo( hkpWorld* pWorld, hkLoader* pLoader );
	static	void	ReleaseInstance();
	static	HavokManager*	Instance()
	{
		return m_pInstance;
	}
private:
	static HavokManager*	m_pInstance;
	HavokManager();

public:
	~HavokManager();

	void	ActiveVisualDebugger();
	void	Update();
	hkpWorld*	GetWorld()
	{
		return m_world;
	}
	hkStopwatch* GetStopwatch()
	{
		return m_stopWatch;
	}

	hkLoader*	GetLoader();

private:
	bool		Init( bool bMultithread );
	bool		InitHavokDemo( hkpWorld* pWorld, hkLoader* pLoader );
	void		UnInit();
	void		StepSimulation( float dt );
	void		StepVisualDebugger( float dt );

private:
	bool				m_bActiveVisualDebugger;
	bool				m_bMultiThread;

	hkJobThreadPool*	m_threadPool;
	hkJobQueue*			m_jobQueue;
	hkpWorld*			m_world;
	hkLoader*			m_pLoader;

	hkVisualDebugger*	m_vdb;
	hkpPhysicsContext*	m_context;
	hkStopwatch*		m_stopWatch;
	hkReal				m_fLastTime;

	bool				m_bHavokDemo;
	
};

#endif